###################################################
### chunk number 1: 
###################################################
library(SpatialExtremes)
library(RandomFields)
image(volcano, col = terrain.colors(100), xaxt = "n", yaxt="n")
contour(volcano, add = TRUE)


###################################################
### chunk number 2:  eval=FALSE
###################################################
## vignette("SpatialExtremesGuide")


###################################################
### chunk number 3: 
###################################################
library(RandomFields)
n.site <- 40
locations <- matrix(runif(2*n.site, 0, 10), ncol = 2)
colnames(locations) <- c("lon", "lat")

ms0 <- MaxStableRF(locations[,1], locations[,2], grid=FALSE, model="wh",
param=c(0,1,.2,3, 1.2), maxstable="extr", n = 80)
ms0 <- t(ms0)


###################################################
### chunk number 4: 
###################################################
fitmaxstab(ms0, locations, cov.mod = "whitmat", fit.marge = FALSE)


###################################################
### chunk number 5:  eval=FALSE
###################################################
## fitmaxstab(ms0, locations, cov.mod = "whitmat", smooth = 1.2, fit.marge = FALSE)


###################################################
### chunk number 6:  eval=FALSE
###################################################
## fitmaxstab(ms0, locations, cov.mod = "cauchy", fit.marge = FALSE)
## fitmaxstab(ms0, locations, cov.mod = "powexp", fit.marge = FALSE)


###################################################
### chunk number 7:  eval=FALSE
###################################################
## sigma = matrix(c(100, 25, 25, 220),ncol = 2)
## sigma.inv = solve(sigma)
## sqrtCinv = t(chol(sigma.inv))
## model = list(list(model = "gauss", var = 1, aniso = sqrtCinv / 2))
## msSmith <- MaxStableRF(locations[,1], locations[,2], grid=FALSE, model=model,
## maxstable="Bool", n = 50)
## msSmith <- t(msSmith)                   
## fitmaxstab(msSmith, locations, cov.mod = "gauss", fit.marge = FALSE)


###################################################
### chunk number 8:  eval=FALSE
###################################################
## fitmaxstab(ms0, locations, cov.mod = "gauss", cov12 = 0, fit.marge = FALSE)
## fitmaxstab(ms0, locations, cov.mod = "cauchy", range = 3, fit.marge = FALSE)


###################################################
### chunk number 9:  eval=FALSE
###################################################
## fitmaxstab(ms0, locations, cov.mod = "gauss", cov12 = 0, fit.marge = FALSE, method = "BFGS")


###################################################
### chunk number 10:  eval=FALSE
###################################################
## ##Smith's model
## fitcovmat(ms0, locations)
## ##Schlather's model with Powered exponential covariance function
## fitcovariance(ms0, locations, "whitmat")


###################################################
### chunk number 11: 
###################################################
x <- c(2.2975896, 1.6448808, 1.3323833, -0.4464904, 2.2737603, -0.2581876, 9.5184398, -0.5899699, 0.4974283, -0.8152157)
gev2frech(x, 1, 2, .2)


###################################################
### chunk number 12:  eval=FALSE
###################################################
## y ~ lat + I(lon^2)


###################################################
### chunk number 13:  eval=FALSE
###################################################
## n.knots <- 5
## knots <- quantile(locations[,2], prob = 1:n.knots/(n.knots+1))
## y ~ rb(lat, knots = knots, degree = 3, penalty = .5)


###################################################
### chunk number 14:  eval=FALSE
###################################################
## n.site <- 20
## locations <- matrix(runif(2*n.site, 0, 10), ncol = 2)
## colnames(locations) <- c("lon", "lat")
## 
## sigma = matrix(c(100, 25, 25, 220),ncol = 2)
## sigma.inv = solve(sigma)
## sqrtCinv = t(chol(sigma.inv))
## model = list(list(model = "gauss", var = 1,
## aniso = sqrtCinv / 2))
## ms0 <- MaxStableRF(locations[,1], locations[,2],
## grid=FALSE, model=model,
## maxstable="Bool",
## n = 50)
## ms1 <- t(ms0)
## param.loc <- -10 + 2 * locations[,2]
## param.scale <- 5 + 2 * locations[,1] + locations[,2]^2
## param.shape <- rep(0.2, n.site)
## 
## for (i in 1:n.site)
## ms1[,i] <- param.scale[i] * (ms1[,i]^param.shape[i] - 1) / param.shape[i] + param.loc[i]


###################################################
### chunk number 15:  eval=FALSE
###################################################
## loc.form <- y ~ lat
## scale.form <- y ~ lon + I(lat^2)
## shape.form <- y ~ 1


###################################################
### chunk number 16:  eval=FALSE
###################################################
## fitmaxstab(ms1, locations, "gauss", loc.form = loc.form, scale.form = scale.form, shape.form= shape.form)


###################################################
### chunk number 17:  eval=FALSE
###################################################
## n.knots <- 5
## knots <- quantile(locations[,2], 1:n.knots/(n.knots+1))
## loc.form <- y ~ rb(lat, knots = knots, degree = 3, penalty = .5)
## fitmaxstab(ms1, locations, "gauss", loc.form = loc.form, scale.form = scale.form, shape.form= shape.form)


###################################################
### chunk number 18:  eval=FALSE
###################################################
## fitmaxstab(ms1, locations, "powexp", loc.form = loc.form, scale.form = scale.form,
##            shape.form= shape.form, scaleCoeff3 = 1)


###################################################
### chunk number 19:  eval=FALSE
###################################################
## fitmaxstab(ms1, locations, "powexp", loc.form = loc.form,
##            scale.form = scale.form, shape.form= shape.form,
##            control = list(ndeps = rep(10^-6, n.par)), method = "BFGS")


###################################################
### chunk number 20: 
###################################################
n.site <- 20
locations <- matrix(runif(2*n.site, 0, 10), ncol = 2)
colnames(locations) <- c("lon", "lat")

sigma = matrix(c(100, 25, 25, 220),ncol = 2)
sigma.inv = solve(sigma)
sqrtCinv = t(chol(sigma.inv))
model = list(list(model = "gauss", var = 1, aniso = sqrtCinv / 2))
ms0 <- MaxStableRF(locations[,1], locations[,2], grid=FALSE, model=model,
                   maxstable="Bool", n = 50)
ms0 <- t(ms0)


###################################################
### chunk number 21:  eval=FALSE
###################################################
## fitmaxstab(ms0, locations, cov.mod = "gauss", fit.marge = FALSE, std.err.type = "score")
## fitmaxstab(ms0, locations, cov.mod = "gauss", fit.marge = FALSE, std.err.type = "grad")


###################################################
### chunk number 22:  eval=FALSE
###################################################
## n.site <- 40
## locations <- matrix(runif(2*n.site, 0, 10), ncol = 2)
## colnames(locations) <- c("lon", "lat")
## 
## ms0 <- MaxStableRF(locations[,1], locations[,2], grid=FALSE, model="stable",
##                    param=c(0,1,0,3, 1.2), maxstable="extr", n = 80)
## ms0 <- t(ms0)
## model1 <- fitmaxstab(ms0, locations, cov.mod = "powexp", fit.marge = FALSE, sill = 1)
## model2 <- fitmaxstab(ms0, locations, cov.mod = "cauchy", fit.marge = FALSE, sill = 1)
## TIC(model1, model2)


###################################################
### chunk number 23:  eval=FALSE
###################################################
## require(RandomFields)
## 
## ##Define the coordinates of each location
## n.site <- 30
## locations <- matrix(rnorm(2*n.site, sd = sqrt(.2)), ncol = 2)
## colnames(locations) <- c("lon", "lat")
## 
## ##Simulate a max-stable process - with unit Frechet margins
## sigma <- matrix(c(100, 25, 25, 220),ncol = 2)
## sigma.inv <- solve(sigma)
## sqrtCinv <- t(chol(sigma.inv))
## model <- list(list(model = "gauss", var = 1, aniso = sqrtCinv / 2))
## ms0 <- MaxStableRF(locations[,1], locations[,2], grid=FALSE, model=model,
##                    maxstable = "Bool", n = 50)
## ms0 <- t(ms0)
## 
## ##Fit three nested models
## M0 <- fitmaxstab(ms0, locations, "gauss", fit.marge = FALSE)
## M1 <- fitmaxstab(ms0, locations, "gauss", fit.marge = FALSE, cov11 =
## 100)
## anova(M0, M1)


###################################################
### chunk number 24:  eval=FALSE
###################################################
## n.site <- 20
## locations <- matrix(runif(2*n.site, 0, 10), ncol = 2)
## colnames(locations) <- c("lon", "lat")
## 
## sigma = matrix(c(100, 25, 25, 220),ncol = 2)
## sigma.inv = solve(sigma)
## sqrtCinv = t(chol(sigma.inv))
## model = list(list(model = "gauss", var = 1, aniso = sqrtCinv / 2))
## ms0 <- MaxStableRF(locations[,1], locations[,2], grid=FALSE, model=model, maxstable="Bool",n = 50)
## ms1 <- t(ms0)
## param.loc <- -10 + 2 * locations[,2]
## param.scale <- 5 + 2 * locations[,1] + locations[,2]^2
## param.shape <- rep(0.2, n.site)
## 
## for (i in 1:n.site)
## ms1[,i] <- param.scale[i] * (ms1[,i]^param.shape[i] - 1) / param.shape[i] + param.loc[i]
## 
## loc.form <- y ~ lat
## scale.form <- y ~ lon + I(lat^2)
## shape.form <- y ~ 1


###################################################
### chunk number 25:  eval=FALSE
###################################################
## fitted <- fitmaxstab(ms1, locations, "gauss", loc.form = loc.form, scale.form = scale.form, shape.form = shape.form)
## predict(fitted)


###################################################
### chunk number 26:  eval=FALSE
###################################################
## new.coord <- cbind(3:6, 7:10)
## colnames(new.coord) <- c("lon", "lat")
## predict(fitted, new.coord)


###################################################
### chunk number 27: fitextcoeff
###################################################
n.site <- 30
locations <- matrix(runif(2*n.site, 0, 10), ncol = 2)
colnames(locations) <- c("lon", "lat")

##Simulates a max-stable process - with unit Frechet margins
ms0 <- MaxStableRF(locations[,1], locations[,2], grid=FALSE, model="wh",
                   param=c(0,1,0,30, .5), maxstable="extr",
                   n = 40)
ms0 <- t(ms0)

##Plots the extremal coefficient function
exco <- fitextcoeff(ms0, locations, estim = "Smith")


###################################################
### chunk number 28: 
###################################################
n.site <- 30
locations <- matrix(runif(2*n.site, 0, 10), ncol = 2)
colnames(locations) <- c("lon", "lat")

##Simulates a max-stable process - with unit Frechet margins
ms0 <- MaxStableRF(locations[,1], locations[,2], grid=FALSE, model="wh",
                   param=c(0,1,0,30, .5), maxstable="extr",
                   n = 40)
ms0 <- t(ms0)

##Plots the extremal coefficient function
exco <- fitextcoeff(ms0, locations, estim = "Smith")


###################################################
### chunk number 29: extcoeff
###################################################
fitted <- fitmaxstab(ms0, locations, "whitmat", fit.marge = FALSE)
extcoeff(fitted)


###################################################
### chunk number 30: 
###################################################
fitted <- fitmaxstab(ms0, locations, "whitmat", fit.marge = FALSE)
extcoeff(fitted)


###################################################
### chunk number 31: covfun
###################################################
covariance(fitted, ylim = c(0,1))
covariance(sill = 1, range = 30, smooth = 0.5, cov.mod = "whitmat", col = 3, add = TRUE)
legend("topright", c("Fitted","Theo"), lty = 1, col = c(1,3), inset = .05)


###################################################
### chunk number 32: 
###################################################
covariance(fitted, ylim = c(0,1))
covariance(sill = 1, range = 30, smooth = 0.5, cov.mod = "whitmat", col = 3, add = TRUE)
legend("topright", c("Fitted","Theo"), lty = 1, col = c(1,3), inset = .05)


###################################################
### chunk number 33: 
###################################################
rbind(fitted = covariance(fitted, dist = seq(0,10, 3))$cov.val,
      theo = covariance(sill = 1, range = 30, smooth = 0.5, cov.mod = "whitmat", dist = seq(0,10, 3))$cov.val)


###################################################
### chunk number 34: mapGEV eval=FALSE
###################################################
## par(mfrow=c(1,3))
## map(fitted, "loc", col = rainbow(80))
## title("Location")
## map(fitted, "scale", col = heat.colors(80))
## title("Scale")
## map(fitted, "shape", col = topo.colors(100))
## title("Shape")


###################################################
### chunk number 35: mapQ50 eval=FALSE
###################################################
## new.ranges <- cbind(c(3, 9), c(2, 10))
## colnames(new.ranges) <- c("lon", "lat")
## 
## map(fitted, "quant", ret.per = 50 , ranges = new.ranges)


